/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";
import * as o from "react";
import e from "prop-types";
import { Popup as Je } from "@progress/kendo-react-popup";
import { cloneDate as ne, getDate as Qe } from "@progress/kendo-date-math";
import { validatePackage as et, useId as tt, useAdaptiveModeContext as nt, usePropsContext as ot, canUseDOM as oe, AsyncFocusBlur as rt, classNames as re, kendoThemeMaps as ae, createPropsContext as at, Keys as D } from "@progress/kendo-react-common";
import { calendarIcon as it } from "@progress/kendo-svg-icons";
import { packageMetadata as lt } from "../package-metadata.mjs";
import { DateInput as ut } from "../dateinput/DateInput.mjs";
import { Calendar as st } from "../calendar/components/Calendar.mjs";
import { nullable as l, MAX_DATE as ct, MIN_DATE as dt, isInDateRange as ft, setTime as mt } from "../utils.mjs";
import { toggleCalendar as ie, messages as pt } from "../messages/index.mjs";
import { useLocalization as gt } from "@progress/kendo-react-intl";
import { ToggleButton as ht } from "./ToggleButton.mjs";
import { PickerWrap as vt } from "../common/PickerWrap.mjs";
import { PickerFloatingLabel as wt } from "../hooks/usePickerFloatingLabel.mjs";
import { ActionSheetContent as bt } from "@progress/kendo-react-layout";
import { AdaptiveMode as yt } from "../common/AdaptiveMode.mjs";
const le = o.forwardRef((n, ue) => {
  et(lt);
  const V = tt(n.id), se = gt(), g = nt(), {
    defaultShow: ce = a.defaultShow,
    defaultValue: de = a.defaultValue,
    dateInput: fe = a.dateInput,
    calendar: me = a.calendar,
    toggleButton: pe = a.toggleButton,
    popup: ge = a.popup,
    pickerWrap: Rt = a.pickerWrap,
    disabled: h = a.disabled,
    format: he = a.format,
    max: P = a.max,
    min: I = a.min,
    popupSettings: v = a.popupSettings,
    tabIndex: ve = a.tabIndex,
    weekNumber: we = a.weekNumber,
    validityStyles: F = a.validityStyles,
    size: S = a.size,
    rounded: E = a.rounded,
    fillMode: x = a.fillMode,
    autoFocus: be = a.autoFocus,
    show: N,
    autoSwitchParts: ye,
    autoSwitchKeys: Ce,
    twoDigitYearMax: Re,
    ariaLabel: ke,
    adaptive: kt,
    adaptiveTitle: De,
    inputAttributes: Oe,
    validationMessage: z,
    _adaptiveMode: Dt = g,
    valid: W,
    focusedDate: Me,
    ...L
  } = ot(Ct, n), B = () => {
    if (oe)
      return b.current && b.current.ownerDocument || window.document;
  }, s = () => !!(p.windowWidth && g && p.windowWidth <= (g == null ? void 0 : g.medium) && n.adaptive), d = () => {
    const t = C.current !== void 0 && C.current !== null ? C.current : n.value !== void 0 ? n.value : p.value;
    return t !== null ? ne(t) : null;
  }, i = () => O.current !== void 0 ? O.current : N !== void 0 ? N : p.show, Pe = () => fe || a.dateInput, Ie = () => pe || a.toggleButton, Se = () => me || a.calendar, Ee = () => ge || a.popup, K = () => n.required !== void 0 ? n.required : !1, T = () => {
    const t = d() || n.value || null, r = I, u = P, M = ft(t, r, u), _ = z !== void 0, q = (!K() || t != null) && M, A = W !== void 0 ? W : q;
    return {
      customError: _,
      rangeOverflow: t && u.getTime() < t.getTime() || !1,
      rangeUnderflow: t && t.getTime() < r.getTime() || !1,
      valid: A,
      valueMissing: t === null
    };
  }, xe = (t) => {
    for (const r of t)
      k({ windowWidth: r.target.clientWidth });
  }, Be = () => {
    c.current && c.current.focus();
  }, H = (t) => {
    y.current = t;
  }, f = (t) => {
    i() !== t && (k({ show: t }), t && n.onOpen && n.onOpen.call(void 0, { target: w.current }), !t && n.onClose && n.onClose.call(void 0, { target: w.current }));
  }, Te = (t) => {
    const r = d();
    return r && t ? mt(t, r) : t;
  }, _e = (t) => {
    v != null && v.onMouseDownOutside && v.onMouseDownOutside.call(void 0, t);
  }, U = (t, r) => {
    k({ value: ne(t || void 0) }), C.current = t, O.current = !1, s() || (m.current = !0), n.onChange && n.onChange.call(void 0, {
      syntheticEvent: r.syntheticEvent,
      nativeEvent: r.nativeEvent,
      value: d(),
      show: i(),
      target: w.current
    }), C.current = void 0, O.current = void 0, f(!1);
  }, qe = (t) => {
    const r = Te(t.value);
    U(r, t);
  }, Y = () => {
    const { popupClass: t, ...r } = v, u = i(), M = d(), _ = M && Qe(M), q = re(t), A = {
      popupClass: "k-datepicker-popup",
      show: u,
      anchor: b.current,
      className: q,
      id: Z,
      anchorAlign: {
        horizontal: "left",
        vertical: "bottom"
      },
      popupAlign: {
        horizontal: "left",
        vertical: "top"
      },
      ...r,
      onMouseDownOutside: _e
    }, ee = {
      disabled: h,
      value: _,
      min: I,
      max: P,
      weekNumber: we,
      focusedDate: Me,
      className: s() ? "k-calendar-lg" : "",
      navigation: !s(),
      onChange: qe
    }, te = Se(), Ge = Ee();
    return s() ? /* @__PURE__ */ o.createElement(te, { _ref: H, ...ee }) : /* @__PURE__ */ o.createElement(Ge, { ...A }, /* @__PURE__ */ o.createElement(te, { _ref: H, ...ee }));
  }, $ = () => {
    k({ focused: !1 }), f(!1);
  }, Ae = () => {
    const { windowWidth: t = 0 } = p, r = {
      expand: i(),
      onClose: $,
      adaptiveTitle: De,
      windowWidth: t
    }, u = Y();
    return /* @__PURE__ */ o.createElement(yt, { ...r }, /* @__PURE__ */ o.createElement(bt, { overflowHidden: !0 }, u));
  }, Ve = (t) => {
    U(t.value, t);
  }, Fe = () => {
    k({ focused: !0 });
  }, Ne = () => {
    f(!i());
  }, j = () => {
    h || (m.current = !0, f(!i()));
  }, ze = (t) => {
    t.preventDefault();
  }, We = (t) => {
    const { altKey: r, keyCode: u } = t;
    if (u === D.esc && i()) {
      m.current = !0, f(!1);
      return;
    }
    r && (u === D.up || u === D.down) && (t.preventDefault(), t.stopPropagation(), m.current = u === D.up, f(u === D.down));
  }, w = o.useRef(null), b = o.useRef(null), c = o.useRef(null), y = o.useRef(null);
  o.useImperativeHandle(
    w,
    () => ({
      props: n,
      get element() {
        return b.current;
      },
      get calendar() {
        return y.current;
      },
      get dateInput() {
        return c.current;
      },
      get name() {
        return n.name;
      },
      get show() {
        return i();
      },
      get validity() {
        return T();
      },
      get value() {
        return d();
      },
      get mobileMode() {
        return s();
      },
      togglePopup: Ne,
      // Hidden Methods but still accessible
      focus: Be
    })
  ), o.useImperativeHandle(ue, () => w.current);
  const C = o.useRef(null), O = o.useRef(void 0), Le = o.useRef(null), m = o.useRef(!1), X = o.useRef(!1), R = o.useRef(null), [p, Ke] = o.useState({
    value: de,
    show: ce,
    focused: !1
  }), [, He] = o.useReducer((t) => t, !0), k = (t) => {
    Ke((r) => ({ ...r, ...t }));
  };
  o.useEffect(() => {
    y.current && y.current.element && i() && !X.current && y.current.element.focus({ preventScroll: !0 }), c.current && c.current.element && !i() && m.current && c.current.element.focus({ preventScroll: !0 }), X.current = i(), m.current = !1;
  }), o.useEffect(() => {
    var t;
    return R.current = oe && window.ResizeObserver && new window.ResizeObserver((r) => xe(r)), i() && He(), (t = B()) != null && t.body && R.current && R.current.observe(B().body), () => {
      var r;
      clearTimeout(Le.current), (r = B()) != null && r.body && R.current && R.current.disconnect();
    };
  }, []);
  const Z = V + "-popup-id", Ue = Y(), Ye = Pe(), $e = d(), je = Ie(), Xe = Ae(), G = !F || T().valid, J = se.toLanguageString(ie, pt[ie]), Ze = {
    disabled: h,
    format: he,
    formatPlaceholder: n.formatPlaceholder,
    id: n.id,
    ariaLabelledBy: n.ariaLabelledBy,
    ariaDescribedBy: n.ariaDescribedBy,
    ariaLabel: ke,
    max: P,
    min: I,
    name: n.name,
    onChange: Ve,
    required: n.required,
    _ref: c,
    tabIndex: i() ? -1 : ve,
    title: n.title,
    valid: T().valid,
    validationMessage: z,
    validityStyles: F,
    value: $e,
    label: void 0,
    placeholder: p.focused ? null : n.placeholder,
    ariaExpanded: i(),
    size: null,
    fillMode: null,
    rounded: null,
    autoFill: n.autoFill,
    twoDigitYearMax: Re,
    enableMouseWheel: n.enableMouseWheel,
    autoCorrectParts: n.autoCorrectParts,
    autoSwitchParts: ye,
    autoSwitchKeys: Ce,
    allowCaretMode: n.allowCaretMode,
    inputAttributes: Oe
  }, Q = /* @__PURE__ */ o.createElement(
    rt,
    {
      onFocus: Fe,
      onBlur: s() ? void 0 : $,
      onSyncBlur: n.onBlur,
      onSyncFocus: n.onFocus
    },
    (t) => /* @__PURE__ */ o.createElement(o.Fragment, null, /* @__PURE__ */ o.createElement(
      "span",
      {
        ...n.label ? {} : L,
        ref: b,
        className: re(
          "k-input",
          "k-datepicker",
          {
            [`k-input-${ae.sizeMap[S] || S}`]: S,
            [`k-rounded-${ae.roundedMap[E] || E}`]: E,
            [`k-input-${x}`]: x,
            "k-invalid": !G,
            "k-required": K(),
            "k-disabled": h
          },
          n.className
        ),
        onKeyDown: We,
        style: { width: n.width },
        onFocus: t.onFocus,
        onBlur: t.onBlur,
        onClick: s() ? j : void 0
      },
      /* @__PURE__ */ o.createElement(
        Ye,
        {
          _ref: c,
          ariaRole: "combobox",
          ariaExpanded: i(),
          ariaControls: Z,
          autoFocus: be,
          ...Ze
        }
      ),
      /* @__PURE__ */ o.createElement(
        je,
        {
          type: "button",
          icon: "calendar",
          svgIcon: it,
          title: J,
          className: "k-input-button",
          rounded: null,
          onClick: s() ? void 0 : j,
          "aria-label": J,
          fillMode: x,
          onMouseDown: ze
        }
      ),
      !s() && Ue
    ), s() && Xe)
  );
  return n.label ? /* @__PURE__ */ o.createElement(
    wt,
    {
      dateInput: c,
      label: n.label,
      editorId: V,
      editorValid: G,
      editorDisabled: h,
      children: Q,
      style: { width: n.width },
      ...L
    }
  ) : Q;
});
le.propTypes = {
  className: e.string,
  defaultShow: e.bool,
  defaultValue: e.instanceOf(Date),
  disabled: e.bool,
  focusedDate: e.instanceOf(Date),
  format: e.oneOfType([
    e.string,
    e.shape({
      skeleton: l(e.string),
      pattern: l(e.string),
      date: l(e.oneOf(["short", "medium", "long", "full"])),
      time: l(e.oneOf(["short", "medium", "long", "full"])),
      datetime: l(e.oneOf(["short", "medium", "long", "full"])),
      era: l(e.oneOf(["narrow", "short", "long"])),
      year: l(e.oneOf(["numeric", "2-digit"])),
      month: l(e.oneOf(["numeric", "2-digit", "narrow", "short", "long"])),
      day: l(e.oneOf(["numeric", "2-digit"])),
      weekday: l(e.oneOf(["narrow", "short", "long"])),
      hour: l(e.oneOf(["numeric", "2-digit"])),
      hour12: l(e.bool),
      minute: l(e.oneOf(["numeric", "2-digit"])),
      second: l(e.oneOf(["numeric", "2-digit"])),
      timeZoneName: l(e.oneOf(["short", "long"]))
    })
  ]),
  formatPlaceholder: e.oneOfType([
    e.oneOf(["wide", "narrow", "short", "formatPattern"]).isRequired,
    e.shape({
      year: e.string.isRequired,
      month: e.string.isRequired,
      day: e.string.isRequired,
      hour: e.string.isRequired,
      minute: e.string.isRequired,
      second: e.string.isRequired
    })
  ]),
  id: e.string,
  ariaLabelledBy: e.string,
  ariaDescribedBy: e.string,
  ariaLabel: e.string,
  min: e.instanceOf(Date),
  max: e.instanceOf(Date),
  name: e.string,
  popupSettings: e.shape({
    animate: e.bool.isRequired,
    appendTo: e.any.isRequired,
    popupClass: e.string.isRequired
  }),
  show: e.bool,
  tabIndex: e.number,
  title: e.string,
  value: e.instanceOf(Date),
  weekNumber: e.bool,
  width: e.oneOfType([e.number, e.string]),
  validationMessage: e.string,
  required: e.bool,
  valid: e.bool,
  size: e.oneOf([null, "small", "medium", "large"]),
  rounded: e.oneOf([null, "small", "medium", "large", "full"]),
  fillMode: e.oneOf([null, "solid", "flat", "outline"]),
  adaptive: e.bool,
  adaptiveTitle: e.string,
  autoFocus: e.bool,
  inputAttributes: e.object
};
const a = {
  defaultShow: !1,
  defaultValue: null,
  dateInput: ut,
  calendar: st,
  toggleButton: ht,
  popup: Je,
  pickerWrap: vt,
  disabled: !1,
  format: "d",
  max: ct,
  min: dt,
  popupSettings: {},
  tabIndex: 0,
  weekNumber: !1,
  validityStyles: !0,
  size: "medium",
  rounded: "medium",
  fillMode: "solid",
  autoFocus: !1
}, Ct = at();
le.displayName = "KendoReactDatePicker";
export {
  le as DatePicker,
  Ct as DatePickerPropsContext,
  a as datePickerDefaultProps
};
