/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const Ve=require("react"),e=require("prop-types"),I=require("@progress/kendo-date-math"),$=require("@progress/kendo-react-buttons"),G=require("@progress/kendo-svg-icons"),Z=require("@progress/kendo-react-intl"),l=require("@progress/kendo-react-common"),pe=require("@progress/kendo-react-labels"),Le=require("@progress/kendo-dateinputs-common"),k=require("./utils.js"),Ne=require("../package-metadata.js"),c=require("../utils.js"),s=require("../messages/index.js"),Ae=require("../timepicker/utils.js"),_e=require("../common/ClearButton.js"),Be=require("./dateInputIntl.js");function je(t){const b=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(t){for(const m in t)if(m!=="default"){const O=Object.getOwnPropertyDescriptor(t,m);Object.defineProperty(b,m,O.get?O:{enumerable:!0,get:()=>t[m]})}}return b.default=t,Object.freeze(b)}const a=je(Ve),Fe="Please enter a valid value!",p=a.forwardRef((t,b)=>{var J;l.validatePackage(Ne.packageMetadata);const m=l.useId(t.id),O=Z.useInternationalization(),E=Z.useLocalization(),Q=l.useUnstyled(),L=l.usePropsContext(V,t).unstyled||Q,{format:w=r.format,size:ee=r.size,rounded:te=r.rounded,fillMode:ne=r.fillMode,formatPlaceholder:ae=r.formatPlaceholder,spinners:re=r.spinners,disabled:C=r.disabled,min:ie=r.min,max:le=r.max,minTime:ue=r.minTime,maxTime:oe=r.maxTime,validityStyles:se=r.validityStyles,validationMessage:N=r.validationMessage,placeholder:y=r.placeholder,enableMouseWheel:ce=r.enableMouseWheel,autoCorrectParts:de=r.autoCorrectParts,autoSwitchParts:fe=r.autoSwitchParts,allowCaretMode:me=r.allowCaretMode,twoDigitYearMax:ge=r.twoDigitYearMax,ariaHasPopup:ve=r.ariaHasPopup,autoFocus:be=r.autoFocus}=l.usePropsContext(V,t),g=()=>M.current!==void 0?M.current:u.current&&u.current.value,A=()=>{const n=u.current&&u.current.currentText||"",i=g();return y!=null&&!we.focused&&!i?y:n},_=()=>t.required!==void 0?t.required:!1,P=()=>{const n=g()||t.value,i=ie,X=le,Te=k.isInRange(n,i,X)&&Ae.isInTimeRange(n,ue,oe),qe=N!==void 0,Se=(!_()||n!=null)&&Te,ke=t.valid!==void 0?t.valid:Se;return{customError:qe,rangeOverflow:n&&X.getTime()<n.getTime()||!1,rangeUnderflow:n&&n.getTime()<i.getTime()||!1,valid:ke,valueMissing:n===null}},ye=()=>{o.current&&o.current.focus()},B=()=>new Be.DateInputIntl(O),R=()=>{const n=g();return{format:w,steps:t.steps,formatPlaceholder:ae,placeholder:y,selectPreviousSegmentOnBackspace:!0,value:t.value||n,intlService:B(),autoFill:t.autoFill!==void 0?t.autoFill:!1,enableMouseWheel:ce,autoCorrectParts:de,autoSwitchParts:fe,autoSwitchKeys:t.autoSwitchKeys||[],twoDigitYearMax:ge,allowCaretMode:me}},he=n=>{d.current&&d.current.classList.add("k-focus"),U({focused:!0})},De=n=>{d.current&&d.current.classList.remove("k-focus"),U({focused:!1})},Ie=(n,i)=>typeof n!=typeof i?!0:typeof n=="string"&&typeof i=="string"?n!==i:typeof n=="object"&&typeof i=="object"?JSON.stringify(n)!==JSON.stringify(i):!1,Oe=n=>typeof n=="string"?n:{inputFormat:n,displayFormat:n},j=n=>{M.current=g(),Pe(),v.current=n,M.current=void 0},F=n=>{t.onChange&&t.onChange(n)},H=n=>{l.getActiveElement(document)===o.current&&n.preventDefault()},Ee=()=>new Le.DateInput(o.current,{...R(),format:Oe(R().format),events:{focus:he,blur:De,valueChange:j,click:F}}),z=()=>{o.current&&o.current.setCustomValidity&&o.current.setCustomValidity(P().valid?"":N||r.validationMessage)},Ce=n=>{!o.current||!u.current||j(n)},Re=n=>{n.preventDefault();const i=l.getActiveElement(document);o.current&&i!==o.current&&o.current.focus({preventScroll:!0})},f=n=>{const i=g();v.current&&t.onChange&&!I.isEqual(v.current.oldValue,i)&&t.onChange.call(void 0,{syntheticEvent:n,nativeEvent:v.current.event,value:v.current.value,target:x.current}),v.current=null},xe=n=>{var i;(i=u.current)==null||i.modifyDateSegmentValue(1),f(n)},Me=n=>{var i;(i=u.current)==null||i.modifyDateSegmentValue(-1),f(n)},x=a.useRef(null),o=a.useRef(null),d=a.useRef(null);a.useImperativeHandle(x,()=>({props:t,get options(){return R()},get text(){return A()},get element(){return o.current},get name(){return t.name},get value(){return g()},get validity(){return P()},focus:ye,updateOnPaste:Ce})),a.useImperativeHandle(b,()=>x.current);const u=a.useRef(null),T=a.useRef(null),q=a.useRef(!1),M=a.useRef(null),v=a.useRef(null),h=a.useRef(t),[we,U]=a.useState({focused:!1}),[,Pe]=a.useReducer(n=>n+1,0);a.useLayoutEffect(()=>{q.current||(u.current=Ee(),T.current=u.current.dateObject,q.current=!0)},[]),a.useEffect(()=>(z(),q.current||d.current&&d.current.addEventListener("wheel",H,{passive:!1}),()=>{d.current&&d.current.removeEventListener("wheel",H)}),[]),a.useEffect(()=>{z(),u.current&&((Ie(h.current.format,w)||h.current.readonly!==t.readonly||h.current.steps!==t.steps||B().locale!==u.current.options.intlService.locale)&&u.current.setOptions(R(),!0),h.current.value!==t.value&&(T.current.getValue()!==null||t.value!==null)&&T.current.setValue(t.value),t.ariaExpanded!==void 0&&t.ariaExpanded&&(u.current.options.placeholder=null),t.ariaExpanded!==void 0&&!t.ariaExpanded&&(u.current.options.placeholder=y),u.current.refreshElementValue(),h.current={format:w,readonly:t.readonly,ariaExpanded:t.ariaExpanded,steps:t.steps,value:t.value})});const W=t.id||m+"-accessibility-id",D=L&&L.uDateInput,K=A(),S=!se||P().valid;a.useImperativeHandle(t._ref,()=>x.current);const Y=a.createElement("span",{ref:n=>d.current=n,style:t.label?void 0:{width:t.width},dir:t.dir,className:l.classNames(l.uDateInput.wrapper({c:D,size:ee,fillMode:ne,rounded:te,disabled:C,required:_(),invalid:!S}),t.className)},a.createElement("input",{ref:n=>o.current=n,role:t.ariaRole||"textbox",readOnly:t.readonly,tabIndex:t.tabIndex||0,disabled:C,title:t.title!==void 0?t.title:K,type:"text",spellCheck:!1,autoComplete:"off",autoCorrect:"off",autoFocus:be,className:l.classNames(l.uDateInput.inputInner({c:D})),id:W,value:K,"aria-label":t.ariaLabel,"aria-labelledby":t.ariaLabelledBy,"aria-describedby":t.ariaDescribedBy,"aria-haspopup":ve,"aria-disabled":C,"aria-expanded":t.ariaExpanded,"aria-controls":t.ariaControls,"aria-required":t.required,"aria-invalid":!S,onKeyDown:f,onChange:f,onWheel:f,onInput:f,onClick:f,name:t.name,...t.inputAttributes}),t.children,t.clearButton&&t.value&&a.createElement(_e,{onClick:F,key:"clearbutton"}),re&&a.createElement("span",{className:l.classNames(l.uDateInput.inputSpinner({c:D})),onMouseDown:Re},a.createElement($.Button,{tabIndex:-1,type:"button",rounded:null,className:l.classNames(l.uDateInput.spinnerIncrease({c:D})),icon:"caret-alt-up",svgIcon:G.caretAltUpIcon,"aria-label":E.toLanguageString(s.increaseValue,s.messages[s.increaseValue]),title:E.toLanguageString(s.increaseValue,s.messages[s.increaseValue]),onClick:xe}),a.createElement($.Button,{tabIndex:-1,type:"button",rounded:null,className:l.classNames(l.uDateInput.spinnerDecrease({c:D})),icon:"caret-alt-down",svgIcon:G.caretAltDownIcon,"aria-label":E.toLanguageString(s.decreaseValue,s.messages[s.decreaseValue]),title:E.toLanguageString(s.decreaseValue,s.messages[s.decreaseValue]),onClick:Me})));return t.label?a.createElement(pe.FloatingLabel,{label:t.label,editorId:W,editorValue:(J=o.current)==null?void 0:J.value,editorValid:S,editorDisabled:C,children:Y,style:{width:t.width}}):Y});p.propTypes={value:e.instanceOf(Date),format:e.oneOfType([c.nullable(e.string),e.shape({skeleton:e.string,pattern:e.string,date:e.oneOf(["short","medium","long","full"]),time:e.oneOf(["short","medium","long","full"]),datetime:e.oneOf(["short","medium","long","full"]),era:e.oneOf(["narrow","short","long"]),year:e.oneOf(["numeric","2-digit"]),month:e.oneOf(["numeric","2-digit","narrow","short","long"]),day:e.oneOf(["numeric","2-digit"]),weekday:e.oneOf(["narrow","short","long"]),hour:e.oneOf(["numeric","2-digit"]),hour12:e.bool,minute:e.oneOf(["numeric","2-digit"]),second:e.oneOf(["numeric","2-digit"]),timeZoneName:e.oneOf(["short","long"])})]),formatPlaceholder:e.oneOfType([e.oneOf(["wide","narrow","short","formatPattern"]).isRequired,e.shape({year:e.string.isRequired,month:e.string.isRequired,day:e.string.isRequired,hour:e.string.isRequired,minute:e.string.isRequired,second:e.string.isRequired})]),width:e.oneOfType([e.string,e.number]),tabIndex:e.number,title:e.string,steps:e.shape({year:c.nullable(e.number),month:c.nullable(e.number),day:c.nullable(e.number),hour:c.nullable(e.number),minute:c.nullable(e.number),second:c.nullable(e.number)}),min:e.instanceOf(Date),max:e.instanceOf(Date),disabled:e.bool,spinners:e.bool,name:e.string,dir:e.string,label:e.string,id:e.string,ariaLabelledBy:e.string,ariaDescribedBy:e.string,ariaLabel:e.string,ariaRole:e.string,ariaHasPopup:e.oneOfType([e.bool,e.oneOf(["grid","dialog"])]),ariaExpanded:e.oneOfType([e.bool]),onChange:e.func,validationMessage:e.string,required:e.bool,valid:e.bool,size:e.oneOf([null,"small","medium","large"]),rounded:e.oneOf([null,"small","medium","large","full"]),fillMode:e.oneOf([null,"solid","flat","outline"]),autoFocus:e.bool,inputAttributes:e.object};const r={format:k.DEFAULT_FORMAT,size:"medium",rounded:"medium",fillMode:"solid",formatPlaceholder:k.DEFAULT_FORMAT_PLACEHOLDER,spinners:!1,disabled:!1,max:I.cloneDate(c.MAX_DATE),min:I.cloneDate(c.MIN_DATE),minTime:I.cloneDate(c.MIN_TIME),maxTime:I.cloneDate(c.MAX_TIME),validityStyles:!0,validationMessage:Fe,placeholder:null,enableMouseWheel:!0,autoCorrectParts:!0,autoSwitchParts:!0,allowCaretMode:!1,twoDigitYearMax:68,ariaHasPopup:"grid",autoFocus:!1},V=l.createPropsContext();p.displayName="KendoReactDateInput";exports.DateInput=p;exports.DateInputPropsContext=V;exports.dateInputDefaultProps=r;
