/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const Ze=require("react"),e=require("prop-types"),Ge=require("@progress/kendo-react-popup"),z=require("@progress/kendo-date-math"),u=require("@progress/kendo-react-common"),Je=require("@progress/kendo-svg-icons"),Qe=require("../package-metadata.js"),et=require("../dateinput/DateInput.js"),tt=require("../calendar/components/Calendar.js"),l=require("../utils.js"),K=require("../messages/index.js"),nt=require("@progress/kendo-react-intl"),at=require("./ToggleButton.js"),ot=require("../common/PickerWrap.js"),rt=require("../hooks/usePickerFloatingLabel.js"),lt=require("@progress/kendo-react-layout"),ut=require("../common/AdaptiveMode.js");function it(n){const h=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(n){for(const f in n)if(f!=="default"){const M=Object.getOwnPropertyDescriptor(n,f);Object.defineProperty(h,f,M.get?M:{enumerable:!0,get:()=>n[f]})}}return h.default=n,Object.freeze(h)}const a=it(Ze),L=a.forwardRef((n,h)=>{u.validatePackage(Qe.packageMetadata);const f=u.useId(n.id),M=nt.useLocalization(),v=u.useAdaptiveModeContext(),{defaultShow:ie=r.defaultShow,defaultValue:se=r.defaultValue,dateInput:ce=r.dateInput,calendar:de=r.calendar,toggleButton:fe=r.toggleButton,popup:me=r.popup,pickerWrap:st=r.pickerWrap,disabled:w=r.disabled,format:ge=r.format,max:S=r.max,min:E=r.min,popupSettings:y=r.popupSettings,tabIndex:pe=r.tabIndex,weekNumber:be=r.weekNumber,validityStyles:W=r.validityStyles,size:T=r.size,rounded:x=r.rounded,fillMode:_=r.fillMode,autoFocus:he=r.autoFocus,show:j,autoSwitchParts:ve,autoSwitchKeys:we,twoDigitYearMax:ye,ariaLabel:ke,adaptive:ct,adaptiveTitle:De,inputAttributes:Ce,validationMessage:H,_adaptiveMode:dt=v,valid:U,focusedDate:Pe,...Y}=u.usePropsContext(ue,n),B=()=>{if(u.canUseDOM)return D.current&&D.current.ownerDocument||window.document},c=()=>!!(b.windowWidth&&v&&b.windowWidth<=(v==null?void 0:v.medium)&&n.adaptive),m=()=>{const t=P.current!==void 0&&P.current!==null?P.current:n.value!==void 0?n.value:b.value;return t!==null?z.cloneDate(t):null},i=()=>q.current!==void 0?q.current:j!==void 0?j:b.show,Re=()=>ce||r.dateInput,Oe=()=>fe||r.toggleButton,Me=()=>de||r.calendar,qe=()=>me||r.popup,$=()=>n.required!==void 0?n.required:!1,A=()=>{const t=m()||n.value||null,o=E,s=S,I=l.isInDateRange(t,o,s),N=H!==void 0,F=(!$()||t!=null)&&I,V=U!==void 0?U:F;return{customError:N,rangeOverflow:t&&s.getTime()<t.getTime()||!1,rangeUnderflow:t&&t.getTime()<o.getTime()||!1,valid:V,valueMissing:t===null}},Ie=t=>{for(const o of t)O({windowWidth:o.target.clientWidth})},Se=()=>{d.current&&d.current.focus()},X=t=>{C.current=t},g=t=>{i()!==t&&(O({show:t}),t&&n.onOpen&&n.onOpen.call(void 0,{target:k.current}),!t&&n.onClose&&n.onClose.call(void 0,{target:k.current}))},Ee=t=>{const o=m();return o&&t?l.setTime(t,o):t},Te=t=>{y!=null&&y.onMouseDownOutside&&y.onMouseDownOutside.call(void 0,t)},Z=(t,o)=>{O({value:z.cloneDate(t||void 0)}),P.current=t,q.current=!1,c()||(p.current=!0),n.onChange&&n.onChange.call(void 0,{syntheticEvent:o.syntheticEvent,nativeEvent:o.nativeEvent,value:m(),show:i(),target:k.current}),P.current=void 0,q.current=void 0,g(!1)},xe=t=>{const o=Ee(t.value);Z(o,t)},G=()=>{const{popupClass:t,...o}=y,s=i(),I=m(),N=I&&z.getDate(I),F=u.classNames(t),V={popupClass:"k-datepicker-popup",show:s,anchor:D.current,className:F,id:te,anchorAlign:{horizontal:"left",vertical:"bottom"},popupAlign:{horizontal:"left",vertical:"top"},...o,onMouseDownOutside:Te},re={disabled:w,value:N,min:E,max:S,weekNumber:be,focusedDate:Pe,className:c()?"k-calendar-lg":"",navigation:!c(),onChange:xe},le=Me(),Xe=qe();return c()?a.createElement(le,{_ref:X,...re}):a.createElement(Xe,{...V},a.createElement(le,{_ref:X,...re}))},J=()=>{O({focused:!1}),g(!1)},_e=()=>{const{windowWidth:t=0}=b,o={expand:i(),onClose:J,adaptiveTitle:De,windowWidth:t},s=G();return a.createElement(ut.AdaptiveMode,{...o},a.createElement(lt.ActionSheetContent,{overflowHidden:!0},s))},Be=t=>{Z(t.value,t)},Ae=()=>{O({focused:!0})},Ne=()=>{g(!i())},Q=()=>{w||(p.current=!0,g(!i()))},Fe=t=>{t.preventDefault()},Ve=t=>{const{altKey:o,keyCode:s}=t;if(s===u.Keys.esc&&i()){p.current=!0,g(!1);return}o&&(s===u.Keys.up||s===u.Keys.down)&&(t.preventDefault(),t.stopPropagation(),p.current=s===u.Keys.up,g(s===u.Keys.down))},k=a.useRef(null),D=a.useRef(null),d=a.useRef(null),C=a.useRef(null);a.useImperativeHandle(k,()=>({props:n,get element(){return D.current},get calendar(){return C.current},get dateInput(){return d.current},get name(){return n.name},get show(){return i()},get validity(){return A()},get value(){return m()},get mobileMode(){return c()},togglePopup:Ne,focus:Se})),a.useImperativeHandle(h,()=>k.current);const P=a.useRef(null),q=a.useRef(void 0),ze=a.useRef(null),p=a.useRef(!1),ee=a.useRef(!1),R=a.useRef(null),[b,Ke]=a.useState({value:se,show:ie,focused:!1}),[,Le]=a.useReducer(t=>t,!0),O=t=>{Ke(o=>({...o,...t}))};a.useEffect(()=>{C.current&&C.current.element&&i()&&!ee.current&&C.current.element.focus({preventScroll:!0}),d.current&&d.current.element&&!i()&&p.current&&d.current.element.focus({preventScroll:!0}),ee.current=i(),p.current=!1}),a.useEffect(()=>{var t;return R.current=u.canUseDOM&&window.ResizeObserver&&new window.ResizeObserver(o=>Ie(o)),i()&&Le(),(t=B())!=null&&t.body&&R.current&&R.current.observe(B().body),()=>{var o;clearTimeout(ze.current),(o=B())!=null&&o.body&&R.current&&R.current.disconnect()}},[]);const te=f+"-popup-id",We=G(),je=Re(),He=m(),Ue=Oe(),Ye=_e(),ne=!W||A().valid,ae=M.toLanguageString(K.toggleCalendar,K.messages[K.toggleCalendar]),$e={disabled:w,format:ge,formatPlaceholder:n.formatPlaceholder,id:n.id,ariaLabelledBy:n.ariaLabelledBy,ariaDescribedBy:n.ariaDescribedBy,ariaLabel:ke,max:S,min:E,name:n.name,onChange:Be,required:n.required,_ref:d,tabIndex:i()?-1:pe,title:n.title,valid:A().valid,validationMessage:H,validityStyles:W,value:He,label:void 0,placeholder:b.focused?null:n.placeholder,ariaExpanded:i(),size:null,fillMode:null,rounded:null,autoFill:n.autoFill,twoDigitYearMax:ye,enableMouseWheel:n.enableMouseWheel,autoCorrectParts:n.autoCorrectParts,autoSwitchParts:ve,autoSwitchKeys:we,allowCaretMode:n.allowCaretMode,inputAttributes:Ce},oe=a.createElement(u.AsyncFocusBlur,{onFocus:Ae,onBlur:c()?void 0:J,onSyncBlur:n.onBlur,onSyncFocus:n.onFocus},t=>a.createElement(a.Fragment,null,a.createElement("span",{...n.label?{}:Y,ref:D,className:u.classNames("k-input","k-datepicker",{[`k-input-${u.kendoThemeMaps.sizeMap[T]||T}`]:T,[`k-rounded-${u.kendoThemeMaps.roundedMap[x]||x}`]:x,[`k-input-${_}`]:_,"k-invalid":!ne,"k-required":$(),"k-disabled":w},n.className),onKeyDown:Ve,style:{width:n.width},onFocus:t.onFocus,onBlur:t.onBlur,onClick:c()?Q:void 0},a.createElement(je,{_ref:d,ariaRole:"combobox",ariaExpanded:i(),ariaControls:te,autoFocus:he,...$e}),a.createElement(Ue,{type:"button",icon:"calendar",svgIcon:Je.calendarIcon,title:ae,className:"k-input-button",rounded:null,onClick:c()?void 0:Q,"aria-label":ae,fillMode:_,onMouseDown:Fe}),!c()&&We),c()&&Ye));return n.label?a.createElement(rt.PickerFloatingLabel,{dateInput:d,label:n.label,editorId:f,editorValid:ne,editorDisabled:w,children:oe,style:{width:n.width},...Y}):oe});L.propTypes={className:e.string,defaultShow:e.bool,defaultValue:e.instanceOf(Date),disabled:e.bool,focusedDate:e.instanceOf(Date),format:e.oneOfType([e.string,e.shape({skeleton:l.nullable(e.string),pattern:l.nullable(e.string),date:l.nullable(e.oneOf(["short","medium","long","full"])),time:l.nullable(e.oneOf(["short","medium","long","full"])),datetime:l.nullable(e.oneOf(["short","medium","long","full"])),era:l.nullable(e.oneOf(["narrow","short","long"])),year:l.nullable(e.oneOf(["numeric","2-digit"])),month:l.nullable(e.oneOf(["numeric","2-digit","narrow","short","long"])),day:l.nullable(e.oneOf(["numeric","2-digit"])),weekday:l.nullable(e.oneOf(["narrow","short","long"])),hour:l.nullable(e.oneOf(["numeric","2-digit"])),hour12:l.nullable(e.bool),minute:l.nullable(e.oneOf(["numeric","2-digit"])),second:l.nullable(e.oneOf(["numeric","2-digit"])),timeZoneName:l.nullable(e.oneOf(["short","long"]))})]),formatPlaceholder:e.oneOfType([e.oneOf(["wide","narrow","short","formatPattern"]).isRequired,e.shape({year:e.string.isRequired,month:e.string.isRequired,day:e.string.isRequired,hour:e.string.isRequired,minute:e.string.isRequired,second:e.string.isRequired})]),id:e.string,ariaLabelledBy:e.string,ariaDescribedBy:e.string,ariaLabel:e.string,min:e.instanceOf(Date),max:e.instanceOf(Date),name:e.string,popupSettings:e.shape({animate:e.bool.isRequired,appendTo:e.any.isRequired,popupClass:e.string.isRequired}),show:e.bool,tabIndex:e.number,title:e.string,value:e.instanceOf(Date),weekNumber:e.bool,width:e.oneOfType([e.number,e.string]),validationMessage:e.string,required:e.bool,valid:e.bool,size:e.oneOf([null,"small","medium","large"]),rounded:e.oneOf([null,"small","medium","large","full"]),fillMode:e.oneOf([null,"solid","flat","outline"]),adaptive:e.bool,adaptiveTitle:e.string,autoFocus:e.bool,inputAttributes:e.object};const r={defaultShow:!1,defaultValue:null,dateInput:et.DateInput,calendar:tt.Calendar,toggleButton:at.ToggleButton,popup:Ge.Popup,pickerWrap:ot.PickerWrap,disabled:!1,format:"d",max:l.MAX_DATE,min:l.MIN_DATE,popupSettings:{},tabIndex:0,weekNumber:!1,validityStyles:!0,size:"medium",rounded:"medium",fillMode:"solid",autoFocus:!1},ue=u.createPropsContext();L.displayName="KendoReactDatePicker";exports.DatePicker=L;exports.DatePickerPropsContext=ue;exports.datePickerDefaultProps=r;
